/*
 * Trivial utility to force sinval resets on demand
 *
 * Create the function with
 *
 * CREATE FUNCTION sinval_reset() RETURNS void AS '/path/to/.so' LANGUAGE c;
 */
#include "postgres.h"

#include "fmgr.h"
#include "storage/lwlock.h"
#include "storage/sinvaladt.h"


Datum		sinval_reset(PG_FUNCTION_ARGS);

PG_FUNCTION_INFO_V1(sinval_reset);


/*
 * This is a copy of SISetProcStateInvalid from
 * src/backend/storage/ipc/sinvaladt.c
 */
static void
SISetProcStateInvalid(SISeg *segP)
{
	int			i;

	segP->minMsgNum = 0;
	segP->maxMsgNum = 0;

	for (i = 0; i < segP->lastBackend; i++)
	{
		if (segP->procState[i].nextMsgNum >= 0) /* active backend? */
		{
			segP->procState[i].resetState = true;
			segP->procState[i].nextMsgNum = 0;
		}
	}
}


/*
 * Exported function
 */
Datum
sinval_reset(PG_FUNCTION_ARGS)
{
	LWLockAcquire(SInvalLock, LW_EXCLUSIVE);
	SISetProcStateInvalid(shmInvalBuffer);
	LWLockRelease(SInvalLock);

	PG_RETURN_NULL();
}
